This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 470909 - Review Request: wt - C++ library and application server for developing web applications
Review Request: wt - C++ library and application server for developing web ap...
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-DEADREVIEW
  Show dependency treegraph
 
Reported: 2008-11-10 15:37 EST by Lorenzo Villani
Modified: 2009-07-30 10:32 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-30 08:43:26 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Lorenzo Villani 2008-11-10 15:37:17 EST
Spec URL: http://fedorapeople.org/gitweb?p=arbiter/public_git/rpm.git;a=blob_plain;f=libs/wt/wt.spec;hb=HEAD
SRPM URL: http://fedorapeople.org/~arbiter/srpm/wt-2.1.5-1.fc10.src.rpm
Description:
Wt (pronounced 'witty') is a C++ library and application server for developing
and deploying web applications. It is not a 'framework', which enforces a way
of programming, but a library.

The API is widget-centric, and inspired by existing C++ Graphical User
Interface (GUI) APIs. To the developer, it offers complete abstraction of any
web-specific implementation details, including event handling and graphics
support.

Page-based frameworks (such as based on PHP or JSP/JSF (+ servlets + struts))
for developing web application do not make abstraction of the peculiarities of
the underlying technologies (HTML/XHTML, JavaScript, CSS, AJAX, Forms, DHTML,
SVG/VML/Canvas). As a consequence, a developer must gain familiarity with all
of these (evolving) technologies. Moreover, when choosing to use a technology
(such the currently popular AJAX), the developer is responsible for graceful
degradation when AJAX or JavaScript are not available or disabled. The
structure of the application follows mostly the page-centric paradigm of early
day HTML. This means that when using advanced AJAX techniques, as a developer
you will need to design and maintain manually your client-server communication.

Generating HTML code or filling HTML templates is prone to security problems
such as XSS (Cross-Site-Scripting), by unwillingly allowing JavaScript to be
inserted in the page. But this cannot be avoided by template frameworks,
because as a developer you need to be able to insert self-written JavaScript to
improve your web application.

In contrast, a web application developed with Wt is written in only one
compiled language (C++), from which the library generates the necessary
HTML/XHTML, Javascript, CGI, SVG/VML/Canvas and AJAX code. The responsibility
of writing secure and browser-portable web applications is handled by Wt.
For example, if available, Wt will maximally use JavaScript and AJAX, but
applications developed using Wt will also function correctly when AJAX is not
available, or when JavaScript is disabled, reverting to a plain HTML/CGI
mechanism for communication between browser and server.

Self-review (*** MUST BE CONFIRMED BY ANOTHER REVIEWER ***)
MUST Items:

- MUST: rpmlint must be run on every package. The output should be posted in the review.
[lorenzo@normandy i386]$ rpmlint wt-2.1.5-1.fc10.i386.rpm
wt.i386: W: non-conffile-in-etc /etc/wt/wt_config.xml
wt.i386: W: shared-lib-calls-exit /usr/lib/libwthttp.so.2.1.5 exit@GLIBC_2.0

[lorenzo@normandy i386]$ rpmlint wt-devel-2.1.5-1.fc10.i386.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

- MUST: The package must be named according to the Package Naming Guidelines (OK)
- MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming Guidelines . (OK)
- MUST: The package must meet the Packaging Guidelines . (NEED CONFIRMATION BY REVIEWER)
- MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines . (OK)
- MUST: The License field in the package spec file must match the actual license. (OK)
- MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
- MUST: The spec file must be written in American English. (OK)
- MUST: The spec file for the package MUST be legible. If the reviewer is unable to read the spec file, it will be impossible to perform a review. Fedora is not the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/). (OK -- Is readable, at least for me)
- MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this. (OK)
- MUST: The package must successfully compile and build into binary rpms on at least one supported architecture. (Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=925191)
- MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch needs to have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number should then be placed in a comment, next to the corresponding ExcludeArch line. New packages will not have bugzilla entries during the review process, so they should put this description in the comment until the package is approved, then file the bugzilla entry, and replace the long explanation with the bug number. The bug should be marked as blocking one (or more) of the following bugs to simplify tracking such issues: FE-ExcludeArch-x86 , FE-ExcludeArch-x64 , FE-ExcludeArch-ppc , FE-ExcludeArch-ppc64 (OK: Package builds on all supported architectures - see scratch build)

- MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
- MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden. (OK: no locales for this package)
- MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. If the package has multiple subpackages with libraries, each subpackage should also have a %post/%postun section that calls /sbin/ldconfig. An example of the correct syntax for this is:

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
(OK)

- MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. (OK)
- MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. Refer to the Guidelines for examples. (OK)
- MUST: A package must not contain any duplicate files in the %files listing. (OK)
- MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. (OK)
- MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). (OK)
- MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines . (OK)
- MUST: The package must contain code, or permissable content. This is described in detail in the code vs. content section of Packaging Guidelines . (OK)
- MUST: Large documentation files should go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity) (OK)
- MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. (OK)
- MUST: Header files must be in a -devel package. (OK)
- MUST: Static libraries must be in a -static package. (OK -- no static libraries present)
- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). (OK)
- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. (OK)
- MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} (OK)
- MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec. (OK)
- MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. This is described in detail in the desktop files section of the Packaging Guidelines . If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. (OK)
- MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. (OK)
- MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for details. (OK)
- MUST: All filenames in rpm packages must be valid UTF-8. (OK)

SHOULD Items:

- SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. (OK)
- SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. (--)
- SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this. (OK)
- SHOULD: The package should compile and build into binary rpms on all supported architectures. (OK)
- SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example. (Tested locally, it works)
- SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. (OK)
- SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. (OK)
- SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. (OK)
- SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. Please see File Dependencies in the Guidelines for further information. (OK)
Comment 1 Patrice Dumas 2008-11-10 15:51:56 EST
The description is too long, in my opinion.

Please have a look at:
http://fedoraproject.org/wiki/PackageMaintainers/Packaging_Tricks#Use_of_common_namespace
Comment 2 Lorenzo Villani 2008-11-12 09:54:29 EST
> The description is too long, in my opinion.
Going to cut it ASAP

> Please have a look at:
> http://fedoraproject.org/wiki/PackageMaintainers/Packaging_Tricks#Use_of_common_namespace

You mean that the package name is too much generic/short? (webtoolkit would be better?)
Comment 3 Michael Schwendt 2008-11-22 07:45:36 EST
> %files
> %defattr(-,root,root,-)
> %doc LICENSE AUTHORS BUGS ReleaseNotes.html
> %{_sysconfdir}/wt/wt_config.xml
> %{_datadir}/Wt/resources/

The following directories are not included:

%{_sysconfdir}/wt
%{_datadir}/Wt

Include the right directories recursively
or use %dir attributes as appropriate.

This is one of the MUST items you've quoted.

> %files devel
> %defattr(-,root,root,-)
> %doc LICENSE AUTHORS BUGS

Even if harddisk space is cheap, why duplicate these files,
which are already found in the main pkg?
Comment 4 Lorenzo Villani 2008-12-06 09:36:11 EST
Spec URL:
http://fedorapeople.org/gitweb?p=arbiter/public_git/rpm.git;a=blob_plain;f=libs/wt/wt.spec;hb=HEAD
SRPM URL: http://fedorapeople.org/~arbiter/srpm/wt-2.1.5-2.fc10.src.rpm

* Sun Nov 23 2008 Lorenzo Villani <lvillani@binaryhelix.net> - 2.1.5-2
- shorter description
- own _includedir/Wt _sysconfdir/wt and _datadir/Wt directory (fix)
- do not duplicate documentation files across packages
Comment 8 Lorenzo Villani 2009-03-19 07:57:35 EDT
Ehrm, sorry, RH's bugzilla was so slow to accept my request that I pushed the reload button a couple of times.
Comment 9 Gianluca Sforna 2009-04-23 17:16:30 EDT
Any reason why you're deviating from the recommended steps for cmake based projects?
https://fedoraproject.org/wiki/Packaging:Cmake#Specfile_Usage
Comment 10 Gianluca Sforna 2009-04-23 18:28:35 EDT
More items to check: as said before the description is really too long and marketing oriented. I propose something like:

===
Wt (pronounced 'witty') is a C++ library and application server for developing and deploying web applications.
A web application developed with Wt is written in only one compiled language (C++), from which the library generates the necessary HTML/XHTML, Javascript, CGI, SVG/VML/Canvas and AJAX code.
===

* The -devel subpackage needs to Require: its dependencies. 

* you are now adding files picking up the whole directories => no more need for explictly owning them with %dir; for example, one of:

%dir %{_includedir}/Wt
%{_includedir}/Wt

is redundant

* The library is GPLv2, but it has the OpenSSL exception, moreover some binaries are under different licenses; from the website:

 -The built-in httpd is based on an example of the asio C++ library, developed by Christopher M. Kohlhoff (Boost Software License).
 -Thread pool implementation from Philipp Henkel (threadpool; Boost Software License).
 -The Mini-XML 2.4 library by Michael Sweet (Mini-XML license , which is LGPL with some exceptions)

Please check everything and compose a complete license field acoording to:
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Multiple_Licensing_Scenarios

* There is some doxygen documentation available, consider packaging it (probably in a -doc subpackage)
Comment 11 Lorenzo Villani 2009-05-08 05:13:45 EDT
SPEC URI: http://github.com/binaryhelix/specs/blob/ab62573a7843d1552daba06883ac52bd08dc6e49/wt/wt.spec
SRPM URI: http://fedorapeople.org/~arbiter/wt/wt-2.2.3-2.fc10.src.rpm

* Fri May 8 2009 Lorenzo Villani <lvillani@binaryhelix.net> - 2.2.3-2
- Require dependencies in -devel subpackage
- Drop redundant declarations in %%files
- Add -doc subpackage
- Fix License tag
Comment 12 Lorenzo Villani 2009-07-30 08:43:26 EDT
My interests shifted to my self-developed REST application framework and I don't need Wt packaged anymore in Fedora.

NOTE: the .spec link and SRPM are broken.

Note You need to log in before you can comment on or make changes to this bug.